#
# spec file for package ghc-persistent
#
# Copyright (c) 2023 SUSE LLC
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.opensuse.org/
#


%global pkg_name persistent
%global pkgver %{pkg_name}-%{version}
%bcond_with tests
Name:           ghc-%{pkg_name}
Version:        2.14.5.1
Release:        1.16
Summary:        Type-safe, multi-backend data serialization
License:        MIT
URL:            https://hackage.haskell.org/package/%{pkg_name}
Source0:        https://hackage.haskell.org/package/%{pkg_name}-%{version}/%{pkg_name}-%{version}.tar.gz
Source1:        https://hackage.haskell.org/package/%{pkg_name}-%{version}/revision/1.cabal#/%{pkg_name}.cabal
BuildRequires:  ghc-Cabal-devel
BuildRequires:  ghc-aeson-devel
BuildRequires:  ghc-aeson-prof
BuildRequires:  ghc-attoparsec-devel
BuildRequires:  ghc-attoparsec-prof
BuildRequires:  ghc-base-devel
BuildRequires:  ghc-base-prof
BuildRequires:  ghc-base64-bytestring-devel
BuildRequires:  ghc-base64-bytestring-prof
BuildRequires:  ghc-blaze-html-devel
BuildRequires:  ghc-blaze-html-prof
BuildRequires:  ghc-bytestring-devel
BuildRequires:  ghc-bytestring-prof
BuildRequires:  ghc-conduit-devel
BuildRequires:  ghc-conduit-prof
BuildRequires:  ghc-containers-devel
BuildRequires:  ghc-containers-prof
BuildRequires:  ghc-deepseq-devel
BuildRequires:  ghc-deepseq-prof
BuildRequires:  ghc-fast-logger-devel
BuildRequires:  ghc-fast-logger-prof
BuildRequires:  ghc-http-api-data-devel
BuildRequires:  ghc-http-api-data-prof
BuildRequires:  ghc-lift-type-devel
BuildRequires:  ghc-lift-type-prof
BuildRequires:  ghc-monad-logger-devel
BuildRequires:  ghc-monad-logger-prof
BuildRequires:  ghc-mtl-devel
BuildRequires:  ghc-mtl-prof
BuildRequires:  ghc-path-pieces-devel
BuildRequires:  ghc-path-pieces-prof
BuildRequires:  ghc-resource-pool-devel
BuildRequires:  ghc-resource-pool-prof
BuildRequires:  ghc-resourcet-devel
BuildRequires:  ghc-resourcet-prof
BuildRequires:  ghc-rpm-macros
BuildRequires:  ghc-scientific-devel
BuildRequires:  ghc-scientific-prof
BuildRequires:  ghc-silently-devel
BuildRequires:  ghc-silently-prof
BuildRequires:  ghc-template-haskell-devel
BuildRequires:  ghc-template-haskell-prof
BuildRequires:  ghc-text-devel
BuildRequires:  ghc-text-prof
BuildRequires:  ghc-th-lift-instances-devel
BuildRequires:  ghc-th-lift-instances-prof
BuildRequires:  ghc-time-devel
BuildRequires:  ghc-time-prof
BuildRequires:  ghc-transformers-devel
BuildRequires:  ghc-transformers-prof
BuildRequires:  ghc-unliftio-core-devel
BuildRequires:  ghc-unliftio-core-prof
BuildRequires:  ghc-unliftio-devel
BuildRequires:  ghc-unliftio-prof
BuildRequires:  ghc-unordered-containers-devel
BuildRequires:  ghc-unordered-containers-prof
BuildRequires:  ghc-vault-devel
BuildRequires:  ghc-vault-prof
BuildRequires:  ghc-vector-devel
BuildRequires:  ghc-vector-prof
ExcludeArch:    %{ix86}
%if %{with tests}
BuildRequires:  ghc-QuickCheck-devel
BuildRequires:  ghc-QuickCheck-prof
BuildRequires:  ghc-hspec-devel
BuildRequires:  ghc-hspec-prof
BuildRequires:  ghc-quickcheck-instances-devel
BuildRequires:  ghc-quickcheck-instances-prof
BuildRequires:  ghc-shakespeare-devel
BuildRequires:  ghc-shakespeare-prof
%endif

%description
Hackage documentation generation is not reliable. For up to date documentation,
please see: <http://www.stackage.org/package/persistent>.

%package devel
Summary:        Haskell %{pkg_name} library development files
Requires:       %{name} = %{version}-%{release}
Requires:       ghc-compiler = %{ghc_version}
Requires(post): ghc-compiler = %{ghc_version}
Requires(postun): ghc-compiler = %{ghc_version}

%description devel
This package provides the Haskell %{pkg_name} library development files.

%package -n ghc-%{pkg_name}-doc
Summary:        Haskell %{pkg_name} library documentation
Requires:       ghc-filesystem
BuildArch:      noarch

%description -n ghc-%{pkg_name}-doc
This package provides the Haskell %{pkg_name} library documentation.

%package -n ghc-%{pkg_name}-prof
Summary:        Haskell %{pkg_name} profiling library
Requires:       ghc-%{pkg_name}-devel = %{version}-%{release}
Supplements:    (ghc-%{pkg_name}-devel and ghc-prof)

%description -n ghc-%{pkg_name}-prof
This package provides the Haskell %{pkg_name} profiling library.

%prep
%autosetup -n %{pkg_name}-%{version}
cp -p %{SOURCE1} %{pkg_name}.cabal

%build
%ghc_lib_build

%install
%ghc_lib_install

%check
%cabal_test

%post devel
%ghc_pkg_recache

%postun devel
%ghc_pkg_recache

%files -f %{name}.files
%license LICENSE

%files devel -f %{name}-devel.files
%doc ChangeLog.md README.md

%files -n ghc-%{pkg_name}-doc -f ghc-%{pkg_name}-doc.files
%license LICENSE

%files -n ghc-%{pkg_name}-prof -f ghc-%{pkg_name}-prof.files

%changelog
* Mon Jul  3 2023 Peter Simons <psimons@suse.com>
- Update persistent to version 2.14.5.1 revision 1.
  Upstream has revised the Cabal build instructions on Hackage.
* Wed Jun 28 2023 Peter Simons <psimons@suse.com>
- Update persistent to version 2.14.5.1.
  [#]# 2.14.5.1
  * [#1496](https://github.com/yesodweb/persistent/pull/1496)
  * Fixes name shadowing error at the generated `keyFromRecordM` function.
  * [#1505](https://github.com/yesodweb/persistent/pull/1505)
  * Fixes the comment line parsing rule so that accommodates paragraph breaks.
* Thu Mar 30 2023 Peter Simons <psimons@suse.com>
- Updated spec file to conform with ghc-rpm-macros-2.5.2.
* Sat Mar  4 2023 Peter Simons <psimons@suse.com>
- Update persistent to version 2.14.5.0.
  Upstream has edited the change log file since the last release in
  a non-trivial way, i.e. they did more than just add a new entry
  at the top. You can review the file at:
  http://hackage.haskell.org/package/persistent-2.14.5.0/src/ChangeLog.md
* Thu Jan  5 2023 Peter Simons <psimons@suse.com>
- Update persistent to version 2.14.4.4.
  [#]# 2.14.4.4
  * [#1460] https://github.com/yesodweb/persistent/pull/1460
  * Fix a problem where a `Primary` key causes `mkPersist` to generate code
    that doesn't compile under `NoFieldSelectors`
* Sat Dec 17 2022 Peter Simons <psimons@suse.com>
- Update persistent to version 2.14.4.3.
  [#]# 2.14.4.3
  * [#1452](https://github.com/yesodweb/persistent/pull/1452)
  * Implement `repsert` as a special case of `respertMany`.  Allows backend
    specific behavior.
* Mon Dec  5 2022 Peter Simons <psimons@suse.com>
- Update persistent to version 2.14.4.2.
  [#]# 2.14.4.2
  * [#1451](https://github.com/yesodweb/persistent/pull/1451)
  * Support `mtl >= 2.3`
  [#]# 2.14.4.1
  * [#1449](https://github.com/yesodweb/persistent/pull/1449)
  * Default implementation for `insert_` which doesn't perform any unnecessary
    queries.
* Sat Dec  3 2022 Peter Simons <psimons@suse.com>
- Update persistent to version 2.14.4.0.
  [#]# 2.14.4.0
  * [#1440](https://github.com/yesodweb/persistent/pull/1440)
  * Defined NFData PersistValue
  [#]# 2.14.3.2
  * [#1446](https://github.com/yesodweb/persistent/pull/1446)
  * Foreign key discovery was fixed for qualified names, `Key Model`, and
    `Maybe` references.
  * [#1438](https://github.com/yesodweb/persistent/pull/1438)
  * Clarify wording on the error message for null in unique constraint
  * [#1447](https://github.com/yesodweb/persistent/pull/1447)
  * Fix `SafeToInsert` not being generated correctly for some `Id` columns
  [#]# 2.14.3.1
  * [#1428](https://github.com/yesodweb/persistent/pull/1428)
  * Fix that the documentation for `discoverEntities` was not being generated.
* Wed Oct 19 2022 Peter Simons <psimons@suse.com>
- Update persistent to version 2.14.3.0 revision 1.
  Upstream has revised the Cabal build instructions on Hackage.
* Mon Sep 12 2022 Peter Simons <psimons@suse.com>
- Update persistent to version 2.14.3.0.
  [#]# 2.14.3.0
  * [#1425](https://github.com/yesodweb/persistent/pull/1425)
  * Introduce an alias `setPsUseSnakeCaseForeignKeys` for
    `setPsUseSnakeCaseForiegnKeys` due to a typo in the latter;
    deprecate `setPsUseSnakeCaseForiegnKeys`
* Wed Aug 24 2022 Peter Simons <psimons@suse.com>
- Update persistent to version 2.14.2.0.
  [#]# 2.14.2.0
  * [#1421](https://github.com/yesodweb/persistent/pull/1421)
  * Add `mpsCamelCaseCompositeKeySelector` field to `MkPersistSettings`,
    which define the style of the entity's composite key.
* Thu Aug 11 2022 Peter Simons <psimons@suse.com>
- Update persistent to version 2.14.1.0.
  [#]# 2.14.1.0
  * [#1418](https://github.com/yesodweb/persistent/pull/1418/)
  * Re-export `SafeToInsert` from `Database.Persist.Class`, which should
    re-export it through `Database.Persist`, `Database.Persist.Sql`, etc.
  * [#1409](https://github.com/yesodweb/persistent/pull/1409)
  * Fix incorrect reference to rawSql in documentation.
* Wed Jul 27 2022 Peter Simons <psimons@suse.com>
- Update persistent to version 2.14.0.3 revision 1.
  Upstream has revised the Cabal build instructions on Hackage.
* Wed Jul 20 2022 Peter Simons <psimons@suse.com>
- Update persistent to version 2.14.0.3.
  [#]# 2.14.0.3
  * [#1411](https://github.com/yesodweb/persistent/pull/1411)
  * Fix the docs for `FieldNameDB`, and update `FieldDef.fieldComments` docs
    since the quasiquoter *supports* field comments now.
* Fri Jun 10 2022 Peter Simons <psimons@suse.com>
- Update persistent to version 2.14.0.2.
  [#]# 2.14.0.2
  * [#1407](https://github.com/yesodweb/persistent/pull/1407)
  * Fix a name shadowing warning.
  [#]# 2.14.0.1
  * [#1392](https://github.com/yesodweb/persistent/pull/1392)
  * Enhance `selectList` documentation with TypeApplications examples.
  * Clarify `selectSource` documentation wording.
  * [#1391](https://github.com/yesodweb/persistent/pull/1391)
  * Increasing quasi module test coverage, improve error assertions
  * [#1401](https://github.com/yesodweb/persistent/pull/1401)
  * Change `Entity` back into a regular record and drop the `HasField`
    instance. This is technically a breaking change, but [the bug in GHC's
    `COMPLETE` annotations](https://gitlab.haskell.org/ghc/ghc/-/issues/15681)
    rendered a super common pattern a much more invasive breaking change than
    anticipated. As a result, upgrading to `persistent-2.14` was untenable.
    If you *did* upgrade and this broke your codebase *again*, please let me
    know and I can release another patch to shim it.
  [#]# 2.14.0.0
  * [#1343](https://github.com/yesodweb/persistent/pull/1343)
  * Implement Type Literal based field definitions
  * [#1387](https://github.com/yesodweb/persistent/pull/1387)
  * Better UX with `insert`. We now report a type error when you try to
    `insert` an `Entity` or a function, and we also forbid `insert`ing if the
    database would throw an error missing a primary key.
  * [#1383](https://github.com/yesodweb/persistent/pull/1383)
  * Primary keys have a `NonEmpty` of fields, not a `[]` of fields.
  * A `Primary` key on an entity now creates a `Unique` constructror for that
    record, with the name `#{entityName}PrimaryKey`. This also affects the
    generation of `AtLeastOneUniqueKey` and `OnlyOneUniqueKey` instances, so
    you may need to change behavior on these classes.
  * [#1381](https://github.com/yesodweb/persistent/pull/1381)
  * `Entity` is given a `HasField` instance that uses the database field
    names. This is primarily done to support `OverloadedRecordDot` in GHC 9.2
    and above.
  * A consequence of this is that the `Entity` constructor has been renamed to
    `Entity'`. A pattern synonym is provided that should work in almost all
    cases. You may incur a `MonadFail m` constraint if you are pattern
    matching directly on the constructor in a `do` result.
  * [#1364](https://github.com/yesodweb/persistent/pull/1346)
  * The type `SomePersistField` was removed in favor of using `PersistValue`
    directly.
  * [#1386](https://github.com/yesodweb/persistent/pull/1386)
  * The module `Database.Persist.Class.DeleteCascade` was deleted since you
    can put cascade behavior directly on your database models.
  * Removed `mkSave` from `Database.Persist.TH`. Use `mkEntityDefList`
    instead.
  * Remove the `CompositeDef` constructor from `ReferenceDef` which was not
    used internally anymore.
  * [#1385](https://github.com/yesodweb/persistent/pull/1385)
  * The support for entity-level sum types is deprecated. It adds a
    considerable amount of complexity to the code, and the pattern is not
    particularly good for actually supporting sum types in most databases.
  * [#1384](https://github.com/yesodweb/persistent/pull/1384)
  * Add `tabulateEntityA` to the `PersistEntity` class, allowing you to
    construct an `Entity a` by providing a function `EntityField a t -> f t`.
    Note that this doesn't make sense for sum entities, and the implementation
    `error`s.
  * Add `tabulateEntity` as a pure version of that.
  [#]# 2.13.3.5
  * [#1374](https://github.com/yesodweb/persistent/pull/1374)
  * Increasing test coverage for errors thrown when parsing entity definitions
  [#]# 2.13.3.4
  * [#1379](https://github.com/yesodweb/persistent/pull/1379)
  * `mkPersist` now generates code that compiles under `NoFieldSelectors` and `DuplicateRecordFields` even if field labels are not prefixed
  * [#1376](https://github.com/yesodweb/persistent/pull/1376)
  * Add coverage for parsing nested parens/lists in field types
  * [#1370](https://github.com/yesodweb/persistent/pull/1370)
  * Add spec to assert Persistent.TH is the only import required when defining entities
* Tue Mar 15 2022 Peter Simons <psimons@suse.com>
- Update persistent to version 2.13.3.3.
  [#]# 2.13.3.3
  * [#1369](https://github.com/yesodweb/persistent/pull/1369)
  * Fix `withObject` needing to be imported
* Mon Mar 14 2022 Peter Simons <psimons@suse.com>
- Update persistent to version 2.13.3.2.
  [#]# 2.13.3.2
  * [#1315](https://github.com/yesodweb/persistent/pull/1315)
  * Refactor entity constraint parsing in Quasi module
  [#]# 2.13.3.1
  * [#1367](https://github.com/yesodweb/persistent/pull/1367),
    [#1366](https://github.com/yesodweb/persistent/pull/1367),
    [#1338](https://github.com/yesodweb/persistent/pull/1338),
    [#1335](https://github.com/yesodweb/persistent/pull/1335)
  * Support GHC 9.2
  * [#1356](https://github.com/yesodweb/persistent/pull/1356)
  * Improve parse errors in generated FromJSON instances
* Sat Jan 29 2022 Peter Simons <psimons@suse.com>
- Update persistent to version 2.13.3.0.
  [#]# 2.13.3.0
  * [#1341](https://github.com/yesodweb/persistent/pull/1341)
  * Add `SqlBackendHooks` to allow for instrumentation of queries.
  * [#1327](https://github.com/yesodweb/persistent/pull/1327)
  * Update `SqlBackend` to use new `StatementCache` interface
    instead of `IORef (Map Text Statement)`
  [#]# 2.13.2.2
  * [#1351](https://github.com/yesodweb/persistent/pull/1351/)
  * `aeson-2.0` support
* Tue Oct 19 2021 psimons@suse.com
- Update persistent to version 2.13.2.1 revision 1.
  Upstream has revised the Cabal build instructions on Hackage.
* Thu Oct 14 2021 psimons@suse.com
- Update persistent to version 2.13.2.1.
  [#]# 2.13.2.1
  * [#1329](https://github.com/yesodweb/persistent/pull/1329)
  * Prevent discovery of constrained `PersistEntity` instances in
    `discoverEntities` (since the discovered instances won't work without
    constraints anyway).
  [#]# 2.13.2.0
  * [#1314](https://github.com/yesodweb/persistent/pull/1314)
  * Fix typos and minor documentation issues in Database.Persist and
    Database.Persist.Quasi.
  * [#1317](https://github.com/yesodweb/persistent/pull/1317)
  * Expose `orderClause` from the Persistent internals, which allows users
    to produce well-formatted `ORDER BY` clauses.
  * [#1319](https://github.com/yesodweb/persistent/pull/1319)
  * Add a `Num` instance for `OverflowNatural`
* Tue Oct 12 2021 psimons@suse.com
- Update persistent to version 2.13.1.2 revision 1.
  Upstream has revised the Cabal build instructions on Hackage.
* Fri Sep  3 2021 psimons@suse.com
- Update persistent to version 2.13.1.2.
  [#]# 2.13.1.2
  * [#1308](https://github.com/yesodweb/persistent/pull/1308)
  * Consolidate the documentation for the Persistent quasiquoter in
    Database.Persist.Quasi.
  * [#1312](https://github.com/yesodweb/persistent/pull/1312)
  * Reorganize documentation and link to more modules.
  * Expose `Database.Persist.Sql.Migration`
* Thu Jul  1 2021 psimons@suse.com
- Update persistent to version 2.13.1.1.
  [#]# 2.13.1.1
  * [#1294](https://github.com/yesodweb/persistent/pull/1294)
  * Fix an issue where documentation comments on fields are in reverse line
    order.
  [#]# 2.13.1.0
  * [#1264](https://github.com/yesodweb/persistent/pull/1264)
  * Support declaring Maybe before the type in model definitions
* Thu Jun 24 2021 psimons@suse.com
- Update persistent to version 2.13.0.4.
  [#]# 2.13.0.4
  * [#1277](https://github.com/yesodweb/persistent/pull/1277)
  * Corrected the documentation of `addMigration` to match the actual
    behaviour - this will not change the behaviour of your code.
* Sat Jun 19 2021 psimons@suse.com
- Update persistent to version 2.13.0.3.
  Upstream has edited the change log file since the last release in
  a non-trivial way, i.e. they did more than just add a new entry
  at the top. You can review the file at:
  http://hackage.haskell.org/package/persistent-2.13.0.3/src/ChangeLog.md
* Wed May 26 2021 psimons@suse.com
- Update persistent to version 2.13.0.2.
  [#]# 2.13.0.2
  * [#1265](https://github.com/yesodweb/persistent/pull/1265)
  * Support GHC 9
* Tue May 11 2021 psimons@suse.com
- Update persistent to version 2.13.0.1.
  Upstream has edited the change log file since the last release in
  a non-trivial way, i.e. they did more than just add a new entry
  at the top. You can review the file at:
  http://hackage.haskell.org/package/persistent-2.13.0.1/src/ChangeLog.md
* Sat May  8 2021 psimons@suse.com
- Update persistent to version 2.13.0.0 revision 2.
  Upstream has revised the Cabal build instructions on Hackage.
* Fri May  7 2021 psimons@suse.com
- Update persistent to version 2.13.0.0 revision 1.
  Upstream has revised the Cabal build instructions on Hackage.
* Thu May  6 2021 psimons@suse.com
- Update persistent to version 2.13.0.0.
  [#]# 2.13.0.0
  * [#1244](https://github.com/yesodweb/persistent/pull/1244)
  * Implement config for customising the FK name
  * [#1252](https://github.com/yesodweb/persistent/pull/1252)
  * `mkMigrate` now defers to `mkEntityDefList` and `migrateModels` instead of
    fixing the foreign key references itself.
  * `mkSave` was deprecated - the function did not fix foreign key references.
    Please use `mkEntityDefList` instead.
  * `EntityDef` will now include fields marked `MigrationOnly` and
    `SafeToRemove`. Beforehand, those were filtered out, and `mkMigrate`
    applied. The function `getEntityFields` wll only return fields defined on
    the Haskell type - for all columns, see `getEntityFieldsDatabase`.
  * [#1225](https://github.com/yesodweb/persistent/pull/1225)
  * The fields and constructor for `SqlBackend` are no longer exported by
    default. They are available from an internal module,
    `Database.Persist.Sql.Types.Internal`. Breaking changes from `Internal`
    modules are not reflected in the major version. This will allow us to
    release new functionality without breaking your code. It's recommended to
    switch to using the smart constructor functions and setter functions that
    are now exported from `Database.Persist.Sql` instead.
  * A new API is available for constructing and using a `SqlBackend`, provided
    in `Database.Persist.SqlBackend`. Instead of using the `SqlBackend`
    directly, use `mkSqlBackend` and the datatype `MkSqlBackendArgs`. The
    `MkSqlBackendArgs` record has the same field names as the `SqlBackend`, so
    the translation is easy:
    ```diff
  - SqlBackend
  + mkSqlBackend MkSqlBackendArgs
    { connInsertSql = ...
    , connCommit = ...
    , connEscapeFieldName = ...
    , connEscapeTableName = ...
    , etc
    }
    ```
    Some fields were omitted in `MkSqlBackendArgs`. These fields are
  * optional* - they provide enhanced or backend-specific functionality. For
    these, use the setter functions like `setConnUpsertSql`.
  * Previously hidden modules are now exposed under the `Internal` namespace.
  * The `connLimitOffset` function used to have a `Bool` parameter. This
    parameter is unused and has been removed.
  * [#1234](https://github.com/yesodweb/persistent/pull/1234)
  * You can now customize the default implied ID column. See the documentation
    in `Database.Persist.ImplicitIdDef` for more details.
  * Moved the various `Name` types into `Database.Persist.Names`
  * Removed the `hasCompositeKey` function. See `hasCompositePrimaryKey` and
    `hasNaturalKey` as replacements.
  * The `EntityDef` constructor and field labels are not exported by default.
    Get those from `Database.Persist.EntityDef.Internal`, but you should
    migrate to the getters/setters in `Database.Persist.EntityDef` as you can.
  * Added the `Database.Persist.FieldDef` and
    `Database.Persist.FieldDef.Internal` modules.
  * The `PersistSettings` type was made abstract. Please migrate to the
    getters/setters defined in that `Database.Persist.Quasi`, or use
    `Database.Persist.Quasi.Internal` if you don't mind the possibility of
    breaking changes.
  * Add the `runSqlCommand` function for running arbitrary SQL during
    migrations.
  * Add `migrateModels` function for a TH-free migration facility.
  * [#1253](https://github.com/yesodweb/persistent/pull/1253)
  * Add `discoverEntities` to discover instances of the class and return their
    entity definitions.
  * [#1250](https://github.com/yesodweb/persistent/pull/1250)
  * The `mpsGeneric` function has been deprecated. If you need this
    functionality, please comment with your needs on the GitHub issue tracker.
    We may un-deprecate it, or we may provide a new and better means of
    facilitating a solution to your problem.
  * [#1255](https://github.com/yesodweb/persistent/pull/1255)
  * `mkPersist` now checks to see if an instance already exists for
    `PersistEntity` for the inputs.
  [#]# 2.12.1.2
  * [#1258](https://github.com/yesodweb/persistent/pull/1258)
  * Support promoted types in Quasi Quoter
  * [#1243](https://github.com/yesodweb/persistent/pull/1243)
  * Assorted cleanup of TH module
  * [#1242](https://github.com/yesodweb/persistent/pull/1242)
  * Refactor setEmbedField to use do notation
  * [#1237](https://github.com/yesodweb/persistent/pull/1237)
  * Remove nonEmptyOrFail function from recent tests
  * [#1256](https://github.com/yesodweb/persistent/pull/1256)
  * The QuasiQuoter has been refactored and improved.
  * You can now use `mkPersistWith` to pass in a list of pre-existing
    `EntityDef` to improve foreign key detection and splitting up models
    across multiple modules.
  * The `entityId` field now returns an `EntityIdDef`, which specifies what
    the ID field actually is. This is a move to better support natural keys.
  * Several types that had lists have been refactored to use nonempty lists to
    better capture the semantics.
  * `mkDeleteCascade` is deprecated. Please use the Cascade behavior directly
    on fields.
  * You can use `Key Foo` and `FooId` interchangeably in fields.
  * Support for GHC < 8.4 dropped.
* Thu Apr 22 2021 psimons@suse.com
- Update persistent to version 2.12.1.1.
  Upstream has edited the change log file since the last release in
  a non-trivial way, i.e. they did more than just add a new entry
  at the top. You can review the file at:
  http://hackage.haskell.org/package/persistent-2.12.1.1/src/ChangeLog.md
* Thu Apr  8 2021 psimons@suse.com
- Update persistent to version 2.12.1.0.
  [#]# 2.12.1.0
  * [#1226](https://github.com/yesodweb/persistent/pull/1226)
  * Expose the `filterClause` and `filterClauseWithValues` functions to support
    the `upsertWhere` functionality in `persistent-postgresql`.
* Mon Apr  5 2021 psimons@suse.com
- Update persistent to version 2.12.0.2.
  Upstream has edited the change log file since the last release in
  a non-trivial way, i.e. they did more than just add a new entry
  at the top. You can review the file at:
  http://hackage.haskell.org/package/persistent-2.12.0.2/src/ChangeLog.md
* Thu Apr  1 2021 psimons@suse.com
- Update persistent to version 2.12.0.1 revision 1.
  Upstream has revised the Cabal build instructions on Hackage.
* Tue Mar 30 2021 psimons@suse.com
- Update persistent to version 2.12.0.1.
  Upstream has edited the change log file since the last release in
  a non-trivial way, i.e. they did more than just add a new entry
  at the top. You can review the file at:
  http://hackage.haskell.org/package/persistent-2.12.0.1/src/ChangeLog.md
* Fri Mar 19 2021 psimons@suse.com
- Update persistent to version 2.11.0.4.
  [#]# 2.11.0.4
  * Fix a compile error [#1213](https://github.com/yesodweb/persistent/pull/1213)
  * That's what I get for running this stuff with flakey CI!
* Thu Mar 18 2021 psimons@suse.com
- Update persistent to version 2.11.0.3.
  [#]# 2.11.0.3
  * Backported the fix from [#1207](https://github.com/yesodweb/persistent/pull/1207) for asynchronous exceptions.
  * Deprecated the `Acquire` family of functions.
* Thu Dec 17 2020 Ondřej Súkup <mimi.vx@gmail.com>
- disable %%{ix86} build
* Sat Dec 12 2020 psimons@suse.com
- Update persistent to version 2.11.0.2.
  Upstream has edited the change log file since the last release in
  a non-trivial way, i.e. they did more than just add a new entry
  at the top. You can review the file at:
  http://hackage.haskell.org/package/persistent-2.11.0.2/src/ChangeLog.md
* Sat Nov  7 2020 psimons@suse.com
- Update persistent to version 2.11.0.1.
  Upstream has edited the change log file since the last release in
  a non-trivial way, i.e. they did more than just add a new entry
  at the top. You can review the file at:
  http://hackage.haskell.org/package/persistent-2.11.0.1/src/ChangeLog.md
* Tue Nov  3 2020 psimons@suse.com
- Update persistent to version 2.10.5.3.
  [#]# 2.10.5.3
  * Backported the fix from [#1135](https://github.com/yesodweb/persistent/pull/1135) to the 2.10 branch.
    This should fix reading `PersistUTCTime` values.
* Tue Aug 18 2020 Peter Simons <psimons@suse.com>
- Replace %%setup -q with the more modern %%autosetup macro.
* Tue Jul 28 2020 Michel Normand <normand@linux.vnet.ibm.com>
- Add _constraints min 4GB disk space for few arches
  aarch64 ppc64 ppc64le
* Tue Jun  9 2020 psimons@suse.com
- Add persistent at version 2.10.5.2.
